#!/usr/bin/env python
# -*- coding:utf-8 -*-

# Program: 购买者查看订单
# Author : HH
# Date   : 2016-02-08

import sys
import mysql.connector
import json

reload(sys)
sys.setdefaultencoding('utf-8')

if __name__ == '__main__':
  '''
  这边模拟用户：username34 订单查询分页为每页一笔订单
  '''
  # 设置公共库连接配置
  db_config_common = {
    'user'    : 'root',
    'password': 'root',
    'host'    : '127.0.0.1',
    'port'    : 3306,
    'database': 'test'
  }
  conn_common = mysql.connector.connect(**db_config_common)
  cursor_select_common = conn_common.cursor(buffered=True)
  # 获得用户:username34的基本信息
  select_sql = '''
    SELECT u.user_id,
      u.table_flag,
      u.db_name,
      ss.value
    FROM user AS u
      LEFT JOIN system_setting AS ss ON u.db_name = ss.name
    WHERE username = 'username77'
  '''
  cursor_select_common.execute(select_sql)
  buy_user_id, buy_table_flag, buy_db_name, buy_db_config_json \
    = cursor_select_common.fetchone()
  # 获得购买者的链接和游标
  conn_buy = mysql.connector.connect(**json.loads(buy_db_config_json))
  cursor_select_buy = conn_buy.cursor(buffered=True)
  # 获得购买者的一笔订单, 直接在后台获取数据传到前台
  select_buy_order_sql = '''
    SELECT buy_order_id,
      user_id,
      user_guide_id
    FROM {buy_order_table}
    WHERE user_id = 34
    LIMIT 0, 1
  '''.format(buy_order_table = 'buy_order_' + str(buy_table_flag))
  cursor_select_buy.execute(select_buy_order_sql)
  buy_order_id, buy_user_id, user_guide_id = cursor_select_buy.fetchone()
  # 使用打印来模拟现实在前台
  print 'buy order info: ', buy_order_id, buy_user_id, user_guide_id
  
  # 通过user_guide_id获得出售者用户信息以及其数据所在的库和表(需要通过ajax来实现)
  sell_info_sql = '''
    SELECT u.user_id,
      ug.user_guide_id,
      u.table_flag,
      u.db_name,
      ss.value AS db_config_json
    FROM user_guide AS ug
      LEFT JOIN user AS u USING(user_id)
      LEFT JOIN system_setting AS ss ON ss.name = u.db_name
    WHERE ug.user_guide_id = {user_guide_id}
  '''.format(user_guide_id = user_guide_id)
  cursor_select_common.execute(sell_info_sql)
  sell_user_id, user_guide_id, sell_table_flag, sell_dbname, \
  sell_db_config_json = cursor_select_common.fetchone()
  
  # 获得出售者的数据库链接描述符以及游标(需要通过ajax来实现)
  conn_sell = mysql.connector.connect(**json.loads(sell_db_config_json))
  cursor_select_sell = conn_sell.cursor(buffered=True)
  # 获得订单商品(需要通过ajax来实现)
  order_goods_sql = '''
    SELECT *
    FROM {order_goods_table}
    WHERE sell_order_id = {buy_order_id}
  '''.format(order_goods_table = 'order_goods_' + str(sell_table_flag),
           buy_order_id = buy_order_id)
  cursor_select_sell.execute(order_goods_sql)
  order_goods = cursor_select_sell.fetchall()
  #使用打印来模拟 ajax 获取数据显示在前台
  for order_good in order_goods:
    print 'order good info: ', order_good
  
  # 关闭有标链接
  cursor_select_common.close()
  cursor_select_buy.close()
  cursor_select_sell.close()

  conn_common.close()
  conn_buy.close()
  conn_sell.close()
