#!/usr/bin/env python
# -*- coding:utf-8 -*-

# Program: 出售者查看订单
# Author : HH
# Date   : 2016-02-09

import sys
import mysql.connector
import json

reload(sys)
sys.setdefaultencoding('utf-8')

if __name__ == '__main__':
  '''
  这边模拟导购：6 查询订单的情况
  '''
  # 设置公共库连接配置
  db_config_common = {
    'user'    : 'root',
    'password': 'root',
    'host'    : '127.0.0.1',
    'port'    : 3306,
    'database': 'test'
  }
  conn_common = mysql.connector.connect(**db_config_common)
  cursor_select_common = conn_common.cursor(buffered=True)
  # 获得导购:6的基本信息
  sell_info_sql = '''
    SELECT u.user_id,
      ug.user_guide_id,
      u.table_flag,
      u.db_name,
      ss.value AS db_config_json
    FROM user_guide AS ug
      LEFT JOIN user AS u USING(user_id)
      LEFT JOIN system_setting AS ss ON ss.name = u.db_name
    WHERE ug.user_guide_id = 6
  '''
  cursor_select_common.execute(sell_info_sql)
  sell_user_id, user_guide_id, sell_table_flag, sell_db_name, \
  sell_db_config_json = cursor_select_common.fetchone()
  # 获得出售者的链接和游标
  conn_sell = mysql.connector.connect(**json.loads(sell_db_config_json))
  cursor_select_sell = conn_sell.cursor(buffered=True)
  # 获得者的一笔订单以及订单商品
  select_sell_order_sql = '''
    SELECT *
    FROM (
      SELECT sell_order_id 
      FROM {sell_order_table}
      WHERE user_guide_id = {user_guide_id}
      LIMIT 0, 1
    ) AS tmp_order
      LEFT JOIN {sell_order_table} USING(sell_order_id)
      LEFT JOIN {order_goods_table} USING(sell_order_id)
  '''.format(sell_order_table = 'sell_order_' + str(sell_table_flag),
             user_guide_id = user_guide_id,
             order_goods_table = 'order_goods_' + str(sell_table_flag))
  cursor_select_sell.execute(select_sell_order_sql)
  # 使用打印来模拟现实在前台显示订单详情
  for sell_order in cursor_select_sell:
    print sell_order

  # 关闭有标链接
  cursor_select_common.close()
  cursor_select_sell.close()

  conn_common.close()
  conn_sell.close()
