#!/usr/bin/env python
# -*- coding:utf-8 -*-

# Program: 店主添加商品
# Author : HH
# Date   : 2016-02-13

import sys
import mysql.connector
import json
import snowflake.client

reload(sys)
sys.setdefaultencoding('utf-8')

if __name__ == '__main__':
  '''
  这边模拟修改导购ID：7 为商店添加商品
  '''
  # 设置公共库连接配置
  db_config_common = {
    'user'    : 'root',
    'password': 'root',
    'host'    : '127.0.0.1',
    'port'    : 3306,
    'database': 'test'
  }
  # 设置snowflake链接默认参数
  snowflake_config = {
    'host': '192.168.137.11',
    'port': 30001
  }
  # 配置snowflake
  snowflake.client.setup(**snowflake_config)
  # 获得公共数据库链接和游标
  conn_common = mysql.connector.connect(**db_config_common)
  cursor_select_common = conn_common.cursor(buffered=True)
  # 获得导购:7的基本信息
  sell_info_sql = '''
    SELECT u.user_id,
      ug.user_guide_id,
      u.table_flag,
      u.db_name,
      ss.value AS db_config_json,
      ug.store_id AS store_id
    FROM user_guide AS ug
      LEFT JOIN user AS u USING(user_id)
      LEFT JOIN system_setting AS ss ON ss.name = u.db_name
    WHERE ug.user_guide_id = 7
  '''
  cursor_select_common.execute(sell_info_sql)
  sell_user_id, user_guide_id, sell_table_flag, sell_db_name, \
  sell_db_config_json, sell_store_id = cursor_select_common.fetchone()
  # 获得出售者的链接和游标
  conn_sell = mysql.connector.connect(**json.loads(sell_db_config_json))
  cursor_dml_sell = conn_sell.cursor(buffered=True)
  # 修改订单3794292705695109121的价格
  insert_goods_sql = '''
    INSERT INTO goods_{table_flag}
    VALUES({gid}, 'goods101', 5320.00, {store_id})
  '''.format(gid = snowflake.client.get_guid(),
             table_flag = sell_table_flag,
             store_id = sell_store_id)

  cursor_dml_sell.execute(insert_goods_sql)
  conn_sell.commit()

  # 关闭有标链接
  cursor_select_common.close()
  cursor_dml_sell.close()

  conn_common.close()
  conn_sell.close()
